/*
				GNU GENERAL PUBLIC LICENSE
                 Version 3, 29 June 2007

 Copyright (C) 2007 Free Software Foundation, Inc. <https://fsf.org/>
 Everyone is permitted to copy and distribute verbatim copies
 of this license document, but changing it is not allowed.

 http-wokou, An HTTP Proxying framework for bypassing DNS Security
 Copyright (C) 2024 Russell Hrubesky, ChiralWorks Software LLC

 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <https://www.gnu.org/licenses/>.

*/

package main

import (
	"encoding/json"
	"fmt"
	"log"
	"os"
	"os/signal"
	"syscall"
	"time"

	httpserver "git.aetherial.dev/aeth/http-proxy/pkg"
)

type Test struct {
	Data *httpserver.AllPageMods
}

func main() {
	var maps Test
	maps.Data = httpserver.LoadPageMods("./config/pagemod/rewrite.json")
	c := make(chan os.Signal)
	signal.Notify(c, os.Interrupt, syscall.SIGTERM)
	go func(ds Test) {
		b, err := json.Marshal(ds)
		if err != nil {
			log.Fatal("failed to marshal struct: ", err)
		}
		<-c
		os.WriteFile("MadeItOutTheJug.json", b, os.ModePerm)
		os.Exit(1)
	}(maps)

	for {
		fmt.Println("sleeping...")
		time.Sleep(15 * time.Second) // or runtime.Gosched() or similar per @misterbee
	}

}
